<template>
  <div class="form-input">
    <label
      v-if="label"
      :for="id"
    >
      {{label}}
    </label>
    <input
      class="form-control"
      :id="id"
      :type="type"
      :name="name"
      :value="value"
      :placeholder="placeholder"
      @input="onInputChange($event.target.value)"
    >
  </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { Component, Prop, Emit } from 'vue-property-decorator';
import { InputResults } from '@/types';

@Component
export default class FormInput extends Vue {
  @Prop({ default: null }) value!: string

  @Prop({ default: null }) label!: string

  @Prop({ default: null }) id!: string

  @Prop({ default: 'text' }) type!: string

  @Prop({ default: null }) name!: string

  @Prop({ default: null }) placeholder!: string

  @Emit('onInputChange')
  onInputChange(value: string): InputResults {
    return {
      key: this.name,
      value,
    };
  }
}
</script>
